<?php
namespace App\Models;
use CodeIgniter\Model;
class PacienteModel extends Model
{
    protected $table      = 'paciente';
    protected $primaryKey = 'id_paciente';

    protected $useAutoIncrement = true;

    protected $returnType     = 'array';
    protected $useSoftDeletes = false;

    protected $allowedFields = ['nombre','fecha_nacimiento','edad','genero','ci','extencion','direccion','telefono','email'];

    protected $useTimestamps = true;
    protected $createdField  = 'fecha_alta';
    protected $updatedField  = 'fecha_modifica';
    protected $deletedField  = '';

    protected $validationRules    = [];
    protected $validationMessages = [];
    protected $skipValidation     = false;

    public function datosAjax($id)
    {
        $this->select('*');
        $this->where('id_paciente', $id);
        $datos = $this->get()->getRow();
        return $datos;
    }

    public function historial($id)
    {
        $this->select('*');
        $this->join('cita', 'cita.id_paciente = paciente.id_paciente');
        $this->join('personal', 'personal.id_personal = cita.id_personal');
        $this->join('servicios', 'servicios.id_servicio = cita.id_servicio');
        $this->where('cita.id_paciente', $id);
        $this->where('estado_cita', 0);
        $datos= $this->orderBy('cita.fecha','DESC')->findAll() ;

        return $datos;
    }

}
?>