<?php
namespace App\Models;
use CodeIgniter\Model;
class PrescripcionModel extends Model
{
    protected $table      = 'prescripcion';
    protected $primaryKey = 'id_prescripcion';

    protected $useAutoIncrement = true;

    protected $returnType     = 'array';
    protected $useSoftDeletes = false;

    protected $allowedFields = ['id_paciente','id_personal','fecha','id_medicamento','dosis','id_cita','indicaciones'];

    protected $useTimestamps = true;
    protected $createdField  = 'fecha_alta';
    protected $updatedField  = 'fecha_modifica';
    protected $deletedField  = '';

    protected $validationRules    = [];
    protected $validationMessages = [];
    protected $skipValidation     = false;

    public function datos($id)
    {
        $this->select('*');
        $this->join('medicamento', 'medicamento.id_medicamento= prescripcion.id_medicamento');
        $this->where('prescripcion.id_cita', $id);
        $datos= $this->orderBy('prescripcion.id_prescripcion','DESC')->findAll() ;

        return $datos;
    }

}
?>