<?php

namespace App\Controllers;

use App\Controllers\BaseController;
use App\Models\ResultadosPruebaModel;
use App\Models\PacienteModel;
use App\Models\LaboratorioModel;
use App\Models\TipolabModel;
use App\Models\DetallePermisosModel;
use App\Models\PermisosModel;

class resultados extends BaseController
{
    protected $resultados, $session, $roles, $reglas, $reglasCambia, $tipolab, $paciente, $laboratorio, $reglas_prescripcion, $permisos, $detalle_rol;

    public function __construct()
    {
        $this->resultados = new ResultadosPruebaModel();
        $this->tipolab = new TipolabModel();
        $this->paciente = new PacienteModel();
        $this->laboratorio = new LaboratorioModel();
        $this->detalle_rol = new DetallePermisosModel();
        $this->permisos = new PermisosModel();
        $this->session = session();

        helper(['form']);


        $this->reglas =
            [
                'id_paciente' =>
                [
                    'rules' => 'required',
                    'errors' => [
                        'required' => 'El campo {field} es obligatorio.',
                    ]
                ],
                'id_laboratorio' =>
                [
                    'rules' => 'required',
                    'errors' => [
                        'required' => 'El campo {field} es obligatorio.',
                    ]
                ],
                'id_tipolab' =>
                [
                    'rules' => 'required',
                    'errors' => [
                        'required' => 'El campo {field} es obligatorio.',
                    ]
                ],
                
                'fecha' =>
                [
                    'rules' => 'required',
                    'errors' => [
                        'required' => 'El campo {field} es obligatorio.',
                    ]
                    ]
            ];

        $this->reglasCambia =
            [
                'id_paciente' =>
                [
                    'rules' => 'required',
                    'errors' => [
                        'required' => 'El campo {field} es obligatorio.',
                        'is_unique' => 'El campo {field} debe ser unico.'
                    ]
                ],
                'id_laboratorio' =>
                [
                    'rules' => 'required',
                    'errors' => [
                        'required' => 'El campo {field} es obligatorio.',
                        'is_unique' => 'El campo {field} debe ser unico.'
                    ]
                ],
                'id_tipolab' =>
                [
                    'rules' => 'required',
                    'errors' => [
                        'required' => 'El campo {field} es obligatorio.',
                        'is_unique' => 'El campo {field} debe ser unico.'
                    ]
                ],
                'fecha' =>
                [
                    'rules' => 'required',
                    'errors' => [
                        'required' => 'El campo {field} es obligatorio.',
                        'is_unique' => 'El campo {field} debe ser unico.'
                    ]
                ]
            ];

    }

    /* INICIO */
    public function index()
    {
        $resultados = $this->resultados->datos();
        $tipolab = $this->tipolab->findAll();
        $paciente = $this->paciente->findAll();
        $laboratorio = $this->laboratorio->findAll();
        $permisos = $this->permisos->nombre_permisos($this->session->id_cargo);


        $data = ['datos' => $resultados, 'tipolabs' => $tipolab, 'pacientes' => $paciente, 'laboratorios' => $laboratorio, 'permisos' => $permisos];
        $view =
            view('header', $data) .
            view('resultados/resultados', $data) .
            view('footer');
        return $view;
    }
    public function insertar()
    {
        if ($this->request->getMethod() == "post" && $this->validate($this->reglas)) {

            $this->resultados->save([
                'fecha' => $this->request->getPost('fecha'),
                'id_paciente' => $this->request->getPost('id_paciente'),
                'id_laboratorio' => $this->request->getPost('id_laboratorio'),
                'id_tipolab' => $this->request->getPost('id_tipolab'),
                'estado_resultado' => 1
            ]);

            return redirect()->to(base_url() . 'resultados');
        } else {
            $resultados = $this->resultados->datos();
            $tipolab = $this->tipolab->findAll();
            $paciente = $this->paciente->findAll();
            $laboratorio = $this->laboratorio->findAll();
            $permisos = $this->permisos->nombre_permisos($this->session->id_cargo);


            $data = ['datos' => $resultados, 'tipolabs' => $tipolab, 'pacientes' => $paciente, 'permisos' => $permisos, 'validation' => $this->validator, 'laboratorios' => $laboratorio];
            $view =
                view('header', $data) .
                view('resultados/resultados', $data) .
                view('footer');
            return $view;
        }
    }

    public function agregar_resultado( ){

        $this->resultados->update($this->request->getPost('id_resultado'), [
    
            'resultado' => $this->request->getPost('resultado'),
            'estado_resultado' => 0,

        ]);

        return redirect()->to(base_url() . 'resultados');
    }

    public function editar($id, $valid = null)
    {
        $resultados = $this->resultados->where('id_resultado', $id)->first();
        $permisos = $this->permisos->nombre_permisos($this->session->id_cargo);
        $tipolab = $this->tipolab->findAll();
        $paciente = $this->paciente->findAll();
        $laboratorio = $this->laboratorio->findAll();

        if ($valid != null) {
            $data = ['datos' => $resultados, 'validation' => $valid, 'permisos' => $permisos, 'tipolabs' => $tipolab, 'pacientes' => $paciente, 'laboratorios' => $laboratorio];
            echo view('header', $data);
            echo view('resultados/editar', $data);
            echo view('footer');
        } else {
            $data = ['datos' => $resultados,'permisos' => $permisos, 'tipolabs' => $tipolab, 'pacientes' => $paciente, 'laboratorios' => $laboratorio];
            echo view('header', $data);
            echo view('resultados/editar', $data);
            echo view('footer');
        }
    }

    public function actualizar()
    {
            if ($this->request->getMethod() == "post" && $this->validate($this->reglasCambia)) {

                $this->resultados->update($this->request->getPost('id_resultado'), [
                    'fecha' => $this->request->getPost('fecha'),
                    'id_paciente' => $this->request->getPost('id_paciente'),
                    'id_laboratorio' => $this->request->getPost('id_laboratorio'),
                    'id_tipolab' => $this->request->getPost('id_tipolab'),
                    'resultado' => $this->request->getPost('resultado'),

                ]);

                return redirect()->to(base_url() . 'resultados');
            } else {

                return $this->editar($this->request->getPost('id_resultados'), $this->validator);
            }
    }


}
