<?php

namespace App\Controllers;

use App\Controllers\BaseController;
use App\Models\PersonalModel;
use App\Models\CargoModel;
use App\Models\EspecialidadModel;
use App\Models\DetallePermisosModel;
use App\Models\PermisosModel;

class Tablero extends BaseController
{
  protected $personal, $session, $cargo, $reglas, $reglasCambia, $especialidad, $reglaslogin, $reglasCambiaClave, $permisos, $detalle_rol;

  public function __construct()
  {
    $this->personal = new PersonalModel();
    $this->cargo = new CargoModel();
    $this->especialidad = new EspecialidadModel();
    $this->detalle_rol = new DetallePermisosModel();
    $this->permisos = new PermisosModel();

    $this->session = session();

    helper(['form']);
  }


  /* INICIO */
  public function index()
  {
    $personal = $this->personal->datos();
    $cargo = $this->cargo->where('estado_cargo', 1)->findAll();
    $especialidad = $this->especialidad->where('estado_especialidad', 1)->findAll();
    $permisos = $this->permisos->nombre_permisos($this->session->id_cargo);


    $data = ['datos' => $personal, 'cargos' => $cargo, 'especialidades' => $especialidad, 'validacion_sw' => 0, 'permisos' => $permisos];



    $db = \Config\Database::connect();
    $consulta = $db->query("SELECT COUNT(*) as cantidad_personal FROM personal p ");
    $resultado = $consulta->getResultArray();
    foreach ($resultado as $row) {
      $cantidad_personal = $row['cantidad_personal'];
    }

    $consulta = $db->query("SELECT COUNT(*) as cantidad_cargo FROM cargo c ");
    $resultado = $consulta->getResultArray();
    foreach ($resultado as $row) {
      $cantidad_cargo = $row['cantidad_cargo'];
    }

    $consulta = $db->query("SELECT COUNT(*) as cantidad_laboratorio FROM laboratorio l ");
    $resultado = $consulta->getResultArray();
    foreach ($resultado as $row) {
      $cantidad_laboratorio = $row['cantidad_laboratorio'];
    }

    $consulta = $db->query("SELECT COUNT(*) as cantidad_paciente FROM paciente p ");
    $resultado = $consulta->getResultArray();
    foreach ($resultado as $row) {
      $cantidad_paciente = $row['cantidad_paciente'];
    }



    $datos = [
      'cantidad_personal' =>  $cantidad_personal,
      'cantidad_cargo' =>  $cantidad_cargo,
      'cantidad_laboratorio' =>  $cantidad_laboratorio,
      'cantidad_paciente' =>  $cantidad_paciente


    ];




    $view =
      view('header', $data) .
      view('tablero/tablero', $datos) .
      view('footer');
    return $view;
  }









  public function formulario_filtro()
  {
    $desde = $this->request->getPost('desde');
    $hasta = $this->request->getPost('hasta');

    $personal = $this->personal->datos();
    $cargo = $this->cargo->where('estado_cargo', 1)->findAll();
    $especialidad = $this->especialidad->where('estado_especialidad', 1)->findAll();
    $permisos = $this->permisos->nombre_permisos($this->session->id_cargo);


    $data = ['datos' => $personal, 'cargos' => $cargo, 'especialidades' => $especialidad, 'validacion_sw' => 0, 'permisos' => $permisos];



    $db = \Config\Database::connect();
    $consulta = $db->query("SELECT COUNT(*) as cantidad_personal FROM personal p ");
    $resultado = $consulta->getResultArray();
    foreach ($resultado as $row) {
      $cantidad_personal = $row['cantidad_personal'];
    }

    $consulta = $db->query("SELECT COUNT(*) as cantidad_cargo FROM cargo c ");
    $resultado = $consulta->getResultArray();
    foreach ($resultado as $row) {
      $cantidad_cargo = $row['cantidad_cargo'];
    }

    $consulta = $db->query("SELECT COUNT(*) as cantidad_laboratorio FROM laboratorio l ");
    $resultado = $consulta->getResultArray();
    foreach ($resultado as $row) {
      $cantidad_laboratorio = $row['cantidad_laboratorio'];
    }

    $consulta = $db->query("SELECT COUNT(*) as cantidad_paciente FROM paciente p ");
    $resultado = $consulta->getResultArray();
    foreach ($resultado as $row) {
      $cantidad_paciente = $row['cantidad_paciente'];
    }




    $query1 = $db->query("SELECT COUNT(*) AS cantidad, c.fecha
                      FROM cita c 
                      INNER JOIN paciente p ON p.id_paciente = c.id_paciente 
                      WHERE c.fecha BETWEEN '$desde' AND '$hasta' 
                      GROUP BY c.fecha;
                      ");

    $datos1 = $query1->getResultArray();


    if (!empty($datos1)) {
      foreach ($datos1 as $dato1) {
        $cantidad[] = $dato1['cantidad'];
        $fecha[] =  $dato1['fecha'];
      }
    } else {

      $cantidad[] = 0;
      $fecha[] = 'No hay movimientos';
    }




    $datos = [
      'labels' =>  $fecha,
      'data1' => $cantidad,
      'cantidad_personal' =>  $cantidad_personal,
      'cantidad_cargo' =>  $cantidad_cargo,
      'cantidad_laboratorio' =>  $cantidad_laboratorio,
      'cantidad_paciente' =>  $cantidad_paciente,
      'desde' => $desde, 'hasta' => $hasta


    ];




    $view =
      view('header', $data) .
      view('tablero/formulario_filtro', $datos) .
      view('footer');
    return $view;
  }



  public function formulario_filtro1()
  {
    $desde = $this->request->getPost('desde');
    $hasta = $this->request->getPost('hasta');

    if (!isset($this->session->id_usuario)) {
      return redirect()->to(base_url());
    }
    $roles = $this->roles->findAll();
    $usuarios = $this->usuarios->datos();
    $permisos = $this->permisos->nombre_permisos($this->session->id_rol);


    $db = \Config\Database::connect();
    $consulta = $db->query("SELECT COUNT(*) as cantidad_clientes_proveedor FROM individuo p ");
    $resultado = $consulta->getResultArray();
    foreach ($resultado as $row) {
      $cantidad_clientes_proveedor = $row['cantidad_clientes_proveedor'];
    }

    $consulta = $db->query("SELECT COUNT(*) as cantidad_maquinaria FROM maquinaria c ");
    $resultado = $consulta->getResultArray();
    foreach ($resultado as $row) {
      $cantidad_maquinaria = $row['cantidad_maquinaria'];
    }

    $consulta = $db->query("SELECT COUNT(*) as cantidad_productos FROM articulos l ");
    $resultado = $consulta->getResultArray();
    foreach ($resultado as $row) {
      $cantidad_productos = $row['cantidad_productos'];
    }

    $consulta = $db->query("SELECT COUNT(*) as cantidad_usuarios FROM usuarios p ");
    $resultado = $consulta->getResultArray();
    foreach ($resultado as $row) {
      $cantidad_usuarios = $row['cantidad_usuarios'];
    }



    $query1 = $db->query("SELECT SUM(dm.cantidad) as cantidad,a.nombre_articulo,a.marca
                            from movimiento_almacen ma inner join detalle_movimiento dm on ma.id_movimiento = dm.id_movimiento
                            inner join articulos a on a.id_articulo = dm.id_articulo
                            where ma.fecha BETWEEN '$desde' and '$hasta' 
                             GROUP BY a.id_articulo");

    $datos1 = $query1->getResultArray();


    if (!empty($datos1)) {
      foreach ($datos1 as $dato1) {
        $cantidad[] = $dato1['cantidad'];
        $articulo[] =  $dato1['nombre_articulo'] . ' ' . $dato1['marca'];
      }
    } else {

      $cantidad[] = 0;
      $articulo[] = 'No hay movimientos';
    }



    $datos = [
      'labels' =>  $articulo,
      'data1' => $cantidad,
      'cantidad_clientes_proveedor' =>  $cantidad_clientes_proveedor,
      'cantidad_maquinaria' =>  $cantidad_maquinaria,
      'cantidad_productos' =>  $cantidad_productos,
      'cantidad_usuarios' =>  $cantidad_usuarios,
      'desde' => $desde,
      'hasta' => $hasta


    ];




    $data = ['datos' => $usuarios, 'permisos' => $permisos, 'roles' => $roles];
    $view =
      view('header', $data) .
      view('tablero/formulario_filtro', $datos) .
      view('footer');
    return $view;
  }





  public function logout()
  {
    $session = session();
    $session->destroy();
    return redirect()->to(base_url());
  }
}
