<?php
$user_session = session();
?>
<script src="https://cdn.jsdelivr.net/npm/chart.js"></script>
<div class="main-content">

    <div class="page-content">
        <div class="container-fluid">

            <div class="row g-3">
                <div class="col-md-12">
                    <div class="page-title-box d-sm-flex align-items-center justify-content-between card flex-sm-row border-0">
                        CLINICA NIEVES > TABLERO
                    </div>
                </div>

                <div class="col-md-3">
                    <div class="card border border-primary">
                        <div class="card-body">
                            <div class="float-end">
                                <div class="avatar-sm mx-auto mb-4">
                                    <span class="avatar-title rounded-circle bg-light font-size-24">
                                        <i class="fa fa-users text-danger"></i>
                                    </span>
                                </div>
                            </div>
                            <div>
                                <p class="text-muted text-uppercase fw-semibold font-size-13">PERSONAL </p>
                                <h4 class="mb-1 mt-1"><span class="counter-value" data-target="<?php echo $cantidad_personal; ?>"><?php echo $cantidad_personal; ?></span></h4>
                            </div>

                        </div>
                    </div>
                </div> <!-- end col-->

                <div class="col-md-3">
                    <div class="card border border-primary">
                        <div class="card-body">
                            <div class="float-end">
                                <div class="avatar-sm mx-auto mb-4">
                                    <span class="avatar-title rounded-circle bg-light font-size-24">
                                        <i class="fa fa-list text-danger"></i>
                                    </span>
                                </div>
                            </div>
                            <div>
                                <p class="text-muted text-uppercase fw-semibold font-size-13">CARGOS </p>
                                <h4 class="mb-1 mt-1"><span class="counter-value" data-target="<?php echo $cantidad_cargo; ?>"><?php echo $cantidad_cargo; ?></span></h4>
                            </div>

                        </div>
                    </div>
                </div> <!-- end col-->

                <div class="col-md-3">
                    <div class="card border border-primary">
                        <div class="card-body">
                            <div class="float-end">
                                <div class="avatar-sm mx-auto mb-4">
                                    <span class="avatar-title rounded-circle bg-light font-size-24">
                                        <i class="fa fa-list text-danger"></i>
                                    </span>
                                </div>
                            </div>
                            <div>
                                <p class="text-muted text-uppercase fw-semibold font-size-13">LABORATORIOS </p>
                                <h4 class="mb-1 mt-1"><span class="counter-value" data-target="<?php echo $cantidad_laboratorio; ?>"><?php echo $cantidad_laboratorio; ?></span></h4>
                            </div>

                        </div>
                    </div>
                </div> <!-- end col-->

                <div class="col-md-3">
                    <div class="card border border-primary">
                        <div class="card-body">
                            <div class="float-end">
                                <div class="avatar-sm mx-auto mb-4">
                                    <span class="avatar-title rounded-circle bg-light font-size-24">
                                        <i class="fa fa-user text-danger"></i>
                                    </span>
                                </div>
                            </div>
                            <div>
                                <p class="text-muted text-uppercase fw-semibold font-size-13">PACIENTES </p>
                                <h4 class="mb-1 mt-1"><span class="counter-value" data-target="<?php echo $cantidad_paciente; ?>"><?php echo $cantidad_paciente; ?></span></h4>
                            </div>

                        </div>
                    </div>
                </div> <!-- end col-->



            </div>

            <form action="<?php echo  base_url(); ?>/tablero/formulario_filtro" method="POST">
                <div class="row">
                    <div class="col-md-4">
                        <b>DESDE</b>
                        <input type="date" class="form-control form-control-sm" name="desde" required>
                    </div>

                    <div class="col-md-4">
                        <b>HASTA</b>
                        <input type="date" class="form-control form-control-sm" name="hasta" required>
                    </div>

                    <div class="col-md-4">
                        <br>
                        <button class="btn btn-danger btn-sm" type="submit"> FILTRAR</button>
                    </div>

                    <div class="col-md-12">
                        <h6>DESDE: <?php echo $desde; ?></h6>
                        <h6>HASTA: <?php echo $hasta; ?></h6>
                        <canvas id="myChart" width="200" height="50"></canvas>
                    </div>

                </div>
            </form>
        </div>
    </div>

    <script>
        // Obtener el contexto del lienzo
        var ctx = document.getElementById('myChart').getContext('2d');

        // Crear el gráfico de barras
        var myChart = new Chart(ctx, {
            type: 'bar',
            data: {
                labels: <?= json_encode($labels) ?>,
                datasets: [{
                    label: 'CONSULTAS MEDICAS  ',
                    data: <?= json_encode($data1) ?>,
                    backgroundColor: '#00aae4',
                    borderColor: '#00aae4',
                    borderWidth: 1
                }]
            },
            options: {
                scales: {
                    yAxes: [{
                        ticks: {
                            beginAtZero: true
                        }
                    }]
                }
            }
        });
    </script>